Index: branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs
===================================================================
--- branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs	(revision 15280)
+++ branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs	(revision 15281)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -139,4 +139,5 @@
       this.xAxisComboBox.Size = new System.Drawing.Size(400, 21);
       this.xAxisComboBox.TabIndex = 7;
+      this.xAxisComboBox.Sorted = false;
       this.xAxisComboBox.SelectedValueChanged += new System.EventHandler(this.AxisComboBox_SelectedValueChanged);
       // 
@@ -160,4 +161,5 @@
       this.yAxisComboBox.Size = new System.Drawing.Size(400, 21);
       this.yAxisComboBox.TabIndex = 5;
+      this.yAxisComboBox.Sorted = false;
       this.yAxisComboBox.SelectedValueChanged += new System.EventHandler(this.AxisComboBox_SelectedValueChanged);
       // 
@@ -183,4 +185,5 @@
       this.sizeComboBox.Name = "sizeComboBox";
       this.sizeComboBox.Size = new System.Drawing.Size(300, 21);
+      this.sizeComboBox.Sorted = false;
       this.sizeComboBox.TabIndex = 14;
       this.sizeComboBox.SelectedValueChanged += new System.EventHandler(this.AxisComboBox_SelectedValueChanged);
@@ -264,5 +267,5 @@
       this.radioButtonGroup.Controls.Add(this.zoomButton);
       this.radioButtonGroup.Controls.Add(this.selectButton);
-      this.radioButtonGroup.Location = new System.Drawing.Point(3, 704);
+      this.radioButtonGroup.Location = new System.Drawing.Point(6, 679);
       this.radioButtonGroup.Name = "radioButtonGroup";
       this.radioButtonGroup.Size = new System.Drawing.Size(122, 32);
@@ -275,5 +278,5 @@
       this.colorRunsButton.Enabled = false;
       this.colorRunsButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
-      this.colorRunsButton.Location = new System.Drawing.Point(131, 713);
+      this.colorRunsButton.Location = new System.Drawing.Point(6, 715);
       this.colorRunsButton.Name = "colorRunsButton";
       this.colorRunsButton.Size = new System.Drawing.Size(21, 21);
@@ -317,5 +320,5 @@
       this.transparencyTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.transparencyTrackBar.LargeChange = 16;
-      this.transparencyTrackBar.Location = new System.Drawing.Point(302, 715);
+      this.transparencyTrackBar.Location = new System.Drawing.Point(177, 717);
       this.transparencyTrackBar.Maximum = 254;
       this.transparencyTrackBar.Name = "transparencyTrackBar";
@@ -331,5 +334,5 @@
       this.hideRunsButton.Enabled = false;
       this.hideRunsButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
-      this.hideRunsButton.Location = new System.Drawing.Point(172, 713);
+      this.hideRunsButton.Location = new System.Drawing.Point(47, 715);
       this.hideRunsButton.Name = "hideRunsButton";
       this.hideRunsButton.Size = new System.Drawing.Size(43, 21);
@@ -347,5 +350,5 @@
       this.colorDialogButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
       this.colorDialogButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
-      this.colorDialogButton.Location = new System.Drawing.Point(152, 713);
+      this.colorDialogButton.Location = new System.Drawing.Point(27, 715);
       this.colorDialogButton.Name = "colorDialogButton";
       this.colorDialogButton.Size = new System.Drawing.Size(14, 21);
@@ -390,5 +393,5 @@
       this.transparencyLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.transparencyLabel.AutoSize = true;
-      this.transparencyLabel.Location = new System.Drawing.Point(233, 717);
+      this.transparencyLabel.Location = new System.Drawing.Point(108, 719);
       this.transparencyLabel.Name = "transparencyLabel";
       this.transparencyLabel.Size = new System.Drawing.Size(75, 13);
Index: branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs
===================================================================
--- branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs	(revision 15280)
+++ branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs	(revision 15281)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -93,4 +93,21 @@
     }
 
+    public string SelectedXAxis {
+      get { return xAxisValue; }
+      set {
+        if (xAxisComboBox.Items.Contains(value)) {
+          xAxisComboBox.SelectedItem = value;
+        }
+      }
+    }
+    public string SelectedYAxis {
+      get { return yAxisValue; }
+      set {
+        if (yAxisComboBox.Items.Contains(value)) {
+          yAxisComboBox.SelectedItem = value;
+        }
+      }
+    }
+
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
@@ -227,10 +244,13 @@
         string[] additionalAxisDimension = Enum.GetNames(typeof(AxisDimension));
         this.xAxisComboBox.Items.AddRange(additionalAxisDimension);
-        this.xAxisComboBox.Items.AddRange(Matrix.ColumnNames.ToArray());
+        var comparer = new HeuristicLab.Common.NaturalStringComparer();
+        var sortedColumnNames = Matrix.ColumnNames.ToArray();
+        sortedColumnNames.StableSort(comparer);
+        this.xAxisComboBox.Items.AddRange(sortedColumnNames);
         this.yAxisComboBox.Items.AddRange(additionalAxisDimension);
-        this.yAxisComboBox.Items.AddRange(Matrix.ColumnNames.ToArray());
+        this.yAxisComboBox.Items.AddRange(sortedColumnNames);
         string[] additionalSizeDimension = Enum.GetNames(typeof(SizeDimension));
         this.sizeComboBox.Items.AddRange(additionalSizeDimension);
-        this.sizeComboBox.Items.AddRange(Matrix.ColumnNames.ToArray());
+        this.sizeComboBox.Items.AddRange(sortedColumnNames);
         this.sizeComboBox.SelectedItem = SizeDimension.Constant.ToString();
 
@@ -415,6 +435,6 @@
         return GetValue(run, sizeDimension);
       } else {
-        int columnIndex = Matrix.ColumnNames.ToList().IndexOf(columnName);
-        IItem value = Content.GetValue(run, columnIndex);
+
+        IItem value = Content.GetValue(run, columnName);
         if (value == null)
           return null;
@@ -431,6 +451,8 @@
         else if (timeSpanValue != null) {
           ret = timeSpanValue.Value.TotalSeconds;
-        } else
+        } else {
+          int columnIndex = Matrix.ColumnNames.ToList().IndexOf(columnName);
           ret = GetCategoricalValue(columnIndex, value.ToString());
+        }
 
         return ret;
@@ -602,24 +624,7 @@
       tooltip = run.Name + System.Environment.NewLine;
 
-      double? xValue = this.GetValue(run, (string)xAxisComboBox.SelectedItem);
-      double? yValue = this.GetValue(run, (string)yAxisComboBox.SelectedItem);
-      double? sizeValue = this.GetValue(run, (string)sizeComboBox.SelectedItem);
-
-      string xString = xValue == null ? string.Empty : xValue.Value.ToString();
-      string yString = yValue == null ? string.Empty : yValue.Value.ToString();
-      string sizeString = sizeValue == null ? string.Empty : sizeValue.Value.ToString();
-
-      //code to handle TimeSpanValues correct
-      int axisDimensionCount = Enum.GetNames(typeof(AxisDimension)).Count();
-      int columnIndex = xAxisComboBox.SelectedIndex - axisDimensionCount;
-      if (xValue.HasValue && columnIndex > 0 && Content.GetValue(0, columnIndex) is TimeSpanValue) {
-        TimeSpan time = TimeSpan.FromSeconds(xValue.Value);
-        xString = string.Format("{0:00}:{1:00}:{2:00.00}", (int)time.TotalHours, time.Minutes, time.Seconds);
-      }
-      columnIndex = yAxisComboBox.SelectedIndex - axisDimensionCount;
-      if (yValue.HasValue && columnIndex > 0 && Content.GetValue(0, columnIndex) is TimeSpanValue) {
-        TimeSpan time = TimeSpan.FromSeconds(yValue.Value);
-        yString = string.Format("{0:00}:{1:00}:{2:00.00}", (int)time.TotalHours, time.Minutes, time.Seconds);
-      }
+      string xString = GetTooltipValue(run, (string)xAxisComboBox.SelectedItem);
+      string yString = GetTooltipValue(run, (string)yAxisComboBox.SelectedItem);
+      string sizeString = GetTooltipValue(run, (string)sizeComboBox.SelectedItem);
 
       tooltip += xAxisComboBox.SelectedItem + " : " + xString + Environment.NewLine;
@@ -628,4 +633,29 @@
 
       return tooltip;
+    }
+
+    private string GetTooltipValue(IRun run, string columnName) {
+      if (columnName == SizeDimension.Constant.ToString())
+        return string.Empty;
+
+      int columnIndex = Matrix.ColumnNames.ToList().IndexOf(columnName);
+
+      //handle non-numeric values correctly
+      if (categoricalMapping.ContainsKey(columnIndex)) {
+        return Content.GetValue(run, columnName).ToString();
+      }
+
+      double? value = GetValue(run, columnName);
+      if (!value.HasValue) return string.Empty;
+
+      string valueString = value.Value.ToString();
+
+      //code to handle TimeSpanValues correctly
+      if (columnIndex > 0 && Content.GetValue(0, columnIndex) is TimeSpanValue) {
+        TimeSpan time = TimeSpan.FromSeconds(value.Value);
+        valueString = string.Format("{0:00}:{1:00}:{2:00.00}", (int)time.TotalHours, time.Minutes, time.Seconds);
+      }
+
+      return valueString;
     }
     #endregion
@@ -726,12 +756,10 @@
     }
     private void hideRunsToolStripMenuItem_Click(object sender, EventArgs e) {
-      //ToList is necessary to prevent lazy evaluation
-      HideRuns(selectedRuns.ToList());
+      HideRuns(selectedRuns);
       //could not use ClearSelectedRuns as the runs are not visible anymore
       selectedRuns.Clear();
     }
     private void hideRunsButton_Click(object sender, EventArgs e) {
-      //ToList is necessary to prevent lazy evaluation
-      HideRuns(selectedRuns.ToList());
+      HideRuns(selectedRuns);
       //could not use ClearSelectedRuns as the runs are not visible anymore
       selectedRuns.Clear();
@@ -739,4 +767,5 @@
 
     private void HideRuns(IEnumerable<IRun> runs) {
+      Content.UpdateOfRunsInProgress = true;
       visibilityConstraint.Active = false;
       if (!Content.Constraints.Contains(visibilityConstraint)) Content.Constraints.Add(visibilityConstraint);
@@ -745,4 +774,5 @@
       }
       visibilityConstraint.Active = true;
+      Content.UpdateOfRunsInProgress = false;
     }
 
Index: branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionChartAggregationView.Designer.cs
===================================================================
--- branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionChartAggregationView.Designer.cs	(revision 15280)
+++ branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionChartAggregationView.Designer.cs	(revision 15281)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionChartAggregationView.cs
===================================================================
--- branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionChartAggregationView.cs	(revision 15280)
+++ branches/Async/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionChartAggregationView.cs	(revision 15281)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
